%% beamerouterthemeKIT.sty: LaTeX style for KIT presentations
%% ==========================================================
%% Author: Dr. Thomas Hertweck, Thomas.Hertweck@kit.edu
%% ==========================================================

\ProvidesPackage{beamerouterthemeKIT}[2025/03/03 v2.0 beamer outer theme KIT]

\tcbuselibrary{fitting,skins}

\def\inserttotalframenumber{999}

%% disable sidebars and headline
\setbeamersize{sidebar width left=0pt}
\setbeamersize{sidebar width right=0pt}
\setbeamertemplate{sidebar left}{}
\setbeamertemplate{sidebar right}{}
\setbeamertemplate{sidebar canvas left}{}
\setbeamertemplate{sidebar canvas right}{}
\setbeamertemplate{headline}{}

%% background grid
\ifkit@grid%
\usetikzlibrary{backgrounds}
\defbeamertemplate*{background canvas}{KIT}{
  \begin{tikzpicture}[show background grid]%
    \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@paper@height);
  \end{tikzpicture}
}%
\else%
\defbeamertemplate*{background canvas}{KIT}{}
\fi

%% set text margins
\setbeamersize{text margin left=\kit@text@marginleft}
\setbeamersize{text margin right=\kit@text@marginright}

%% standard background
\defbeamertemplate*{background}{KIT}{%
  \begin{tikzpicture}%
    % setup bounding box
    \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@paper@height);
    % navigation symbols
    \ifthenelse{\boolean{kit@nav@use}}{%
        \pgftext[at=\pgfpoint{\kit@paper@width-\kit@text@marginright}{\kit@paper@height},top,right]%
          {\usebeamercolor*[fg]{navigation symbols}\expandafter\kit@ins@nav\kit@nav@syms}%
    }{}%
  \end{tikzpicture}%
}

%% frame title 
\defbeamertemplate*{frametitle}{KIT}[1][left]{%
  \nointerlineskip
  \begin{tikzpicture}
    \useasboundingbox (0,0) rectangle (\kit@frametitle@width,-\kit@frametitle@height);
    % size will automatically be adjusted as required to fit the content into the frametitle
    % box; adjustments should only ever happen for very long titles and/or subtitles
    \tcbset{notitle,colback=white,nobeforeafter,halign=left,valign=top,fit,opacityfill=0,%
            fit algorithm=areasize,size=minimal,fit fontsize macros}
    \node[inner sep=0pt,outer sep=0pt,anchor=north west] (titletext)
    at (\kit@frametitle@text@upperleftx-\kit@frametitle@marginleft,\kit@frametitle@text@upperlefty-\kit@paper@height)%
{% begin node
\tcboxfit[width=\kit@frametitle@text@width,height=\kit@frametitle@text@height,fit warning=off] {%
{\usebeamerfont{frametitle}\usebeamercolor*[fg]{frametitle}\strut\insertframetitle\strut\par}%
\ifx\insertframesubtitle\@empty{{\usebeamerfont{framesubtitle}\strut\par}}\else%
{\usebeamerfont{framesubtitle}\usebeamercolor*[fg]{framesubtitle}\strut\insertframesubtitle\strut\par}\fi%
}% end tcboxfit
};% end node
  \end{tikzpicture}%
  \ifkit@strict\vskip 0.4ex\else\relax\fi%
  \ifthenelse{\equal{\insertaspectratio}{43}}{\vskip -0.7ex\relax}{}%
}

%% footline
\newlength{\myalen}
\newlength{\myblen}
\newcommand{\kit@footer@sep}{%
  \settowidth{\myalen}{\insertshortauthor}%
  \settowidth{\myblen}{\insertshorttitle}%
  \ifdim\myalen>0.1em\ifdim\myblen>0.1em{\usebeamercolor*[fg]{shorttitle}~--~}\else\relax\fi\else\relax\fi%
}
\newcommand{\kit@footer@shortinst}{%
  \settowidth{\myalen}{\insertshortauthor}%
  \settowidth{\myblen}{\insertshortinstitute}%
  \ifdim\myalen>0.1em\ifdim\myblen>0.1em{\usebeamercolor*[fg]{shortinstitute}~(\insertshortinstitute)}\else\relax\fi\else\relax\fi%
}
%\newcommand{\kit@footer@addtotal}{~|~\inserttotalframenumber\relax}
% ignore frames in the appendix
\newcommand{\kit@footer@addtotal}{~|~\insertmainframenumber\relax}
\newlength{\kit@pageprogress}
\newcommand{\kit@appendix@framenumber}{\@empty}
\defbeamertemplate*{footline}{KIT}{%
  \begin{tikzpicture}%
    \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@footer@height);%
    \ifnum\insertframenumber>\insertmainframenumber%
    \renewcommand{\kit@appendix@framenumber}{\the\numexpr\insertframenumber-\insertmainframenumber}%
    \pgftext[at=\pgfpoint{\kit@text@marginleft}{\kit@footer@unilogo@lowerrighty},left,base]%
      {\usebeamerfont{pageno}\usebeamercolor*[fg]{pageno}A\kit@appendix@framenumber}%
    \else%
    \pgftext[at=\pgfpoint{\kit@text@marginleft}{\kit@footer@unilogo@lowerrighty},left,base]%
     {\usebeamerfont{pageno}\usebeamercolor*[fg]{pageno}\insertframenumber%
     \ifkit@showtotal\kit@footer@addtotal\fi}%
    \fi%
    \pgftext[at=\pgfpoint{\kit@footer@date@leftx}{\kit@footer@unilogo@lowerrighty},left,base]%
      {\usebeamerfont{shortdate}\usebeamercolor*[fg]{shortdate}\numdate\insertshortdate}%
    \pgftext[at=\pgfpoint{\kit@footer@author@leftx}{\kit@footer@unilogo@lowerrighty},left,base]%
      {{\usebeamerfont{shortauthor}\usebeamercolor*[fg]{shortauthor}\insertshortauthor}%
      \kit@footer@shortinst\kit@footer@sep%
      {\usebeamerfont{shorttitle}\usebeamercolor*[fg]{shorttitle}\insertshorttitle}%
      \ifKITconfidential%
      \hspace*{1em}{\textcolor{KITred}{\kit@confidential}}%
      \else%
      \ifkit@footlic\ifkit@lic\hspace*{1em}{\usebeamercolor*[fg]{shortliclogo}\kit@liclogo@type}\fi\fi%
      \fi}
      \ifkit@progressbar%
        %\setlength{\kit@pageprogress}{\kit@paper@width*\ratio{\insertframenumber pt}{\inserttotalframenumber pt}}%
        % ignore frames in the appendix
        \setlength{\kit@pageprogress}{\kit@paper@width*\ratio{\insertframenumber pt}{\insertmainframenumber pt}}%
        \fill[KITgray] (0,0) rectangle (\kit@paper@width,\kit@pageprogress@linewidth);%
        \fill[KITlightgray] (0,0) rectangle (\kit@pageprogress,\kit@pageprogress@linewidth);%
      \fi%
      \node[inner sep=0pt,outer sep=0pt,anchor=south east] (kitlogo) at (\kit@footer@unilogo@lowerrightx,\kit@footer@unilogo@lowerrighty)%
        {\href{https://www.kit.edu}{\includegraphics[width=\kit@footer@unilogo@width]{\kit@footer@unilogo@file}}};%
  \end{tikzpicture}%
}

%% title page 
\defbeamertemplate*{title page}{KIT}{%
  \begin{textblock*}{\kit@paper@width}(0pt,0pt)
    \begin{tikzpicture}
      % setup bounding box
      \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@paper@height);
      \fill[KITbluegreen] (0,0) rectangle (\kit@titlepage@image@leftx,\kit@paper@height);
      % color box
      \fill[KITtitlepageboxcolor] (\kit@titlepage@cbox@leftx,\kit@titlepage@cbox@lowery)%
                                  rectangle ++(\kit@titlepage@cbox@width,\kit@titlepage@cbox@height);
      % set titlepage graphic
      \ifthenelse{\equal{\inserttitlegraphic}{}}{}{%
        \begin{scope}%
          \clip (\kit@titlepage@image@leftx,\kit@titlepage@image@lowery)%
                rectangle ++(\kit@titlepage@image@width,\kit@titlepage@image@height);
          \node[inner sep=0pt,outer sep=0pt] at (\kit@titlepage@image@centerx,\kit@titlepage@image@centery) {\inserttitlegraphic};
        \end{scope}
      }%
      % set KIT logo
      \ifthenelse{\equal{\kit@titlepage@unilogo@file}{\@empty}}{}{%
           \node[inner sep=0pt,outer sep=0pt] (unilogo) at (\kit@titlepage@unilogo@centerx,\kit@titlepage@unilogo@centery)%
           {\includegraphics[width=\kit@titlepage@unilogo@width]{\kit@titlepage@unilogo@file}};
      }%
      % set additional logo if present
      \node[inner sep=0pt,outer sep=0pt] at (\kit@titlepage@instlogo@centerx,\kit@titlepage@instlogo@centery) {\insertlogo\relax};
      % set title, subtitle and authors
      % size will automatically be adjusted as required to fit the content into the box
      % adjustments should only ever happen for very long titles and/or subtitles
      \tcbset{notitle,nobeforeafter,halign=flush left,valign=top,enhanced,opacityfill=0,%
              fit algorithm=areasize,size=minimal,fit fontsize macros}
      \begingroup%
      \ifthenelse{\equal{\kit@titlepage@orientation}{horizontal} \AND%
                  \equal{\kit@titlepage@background}{KITwhite}}{%
        \setbeamercolor{title}{fg=KITbluegreen}%
        \setbeamercolor{subtitle}{fg=KITbluegreen}%
        \setbeamercolor{date}{fg=KITdarkblue}%
        \setbeamercolor{author}{fg=KITdarkblue}%
      }{}%
      \node[inner sep=0pt,outer sep=0pt,anchor=north west] at (\kit@titlepage@tbox@upperleftx,\kit@titlepage@tbox@upperlefty){%
        \tcboxfit[width=\kit@titlepage@tbox@width,height=\kit@titlepage@tbox@height,fit warning=off]{%
          {\usebeamerfont{title}\usebeamercolor*[fg]{title}\inserttitle\par}%
          {\vspace*{\kit@titlepage@tbox@vspace}\usebeamerfont{subtitle}\usebeamercolor*[fg]{subtitle}\insertsubtitle\par}%
        }%
      };%
      \node[inner sep=0pt,outer sep=0pt,anchor=south west] (datebox) at (\kit@titlepage@dbox@lowerleftx,\kit@titlepage@dbox@lowerlefty){%
        {\usebeamerfont{date}\usebeamercolor*[fg]{date}\numdate\insertdate\par}};%
      \ifx\insertinstitute\@empty%
      \node[inner sep=0pt,outer sep=0pt,anchor=south west,text width=\kit@titlepage@tbox@width] (instbox) at (datebox.north west){\par};%
      \else%
        \node[inner sep=0pt,outer sep=0pt,anchor=south west,text width=\kit@titlepage@tbox@width,yshift=3pt] (instbox) at (datebox.north west){%
          \usebeamerfont{author}\usebeamercolor*[fg]{author}\insertinstitute\par};%
      \fi%
      \node[inner sep=0pt,outer ysep=0pt,anchor=south west,text width=\kit@titlepage@tbox@width,yshift=3pt] at (instbox.north west){%
        {\usebeamerfont{author}\usebeamercolor*[fg]{author}\insertauthor\par}%
      };%
      \endgroup%
    \end{tikzpicture}
  \end{textblock*}
}

%% section page
\defbeamertemplate*{section page}{KIT}{%
  \begin{textblock*}{\kit@paper@width}(0pt,0pt)
    \begingroup%
    \begin{tikzpicture}
      % setup bounding box
      \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@paper@height);
      % set sectionpage graphic
      \ifthenelse{\equal{\kit@sectionpage@includeimage}{}}{}{%
        \begin{scope}%
          \clip (\kit@sectionpage@image@leftx,\kit@sectionpage@image@lowery)%
                rectangle ++(\kit@sectionpage@image@width,\kit@sectionpage@image@height);
          \node[inner sep=0pt,outer sep=0pt] at (\kit@sectionpage@image@centerx,\kit@sectionpage@image@centery) {\kit@sectionpage@includeimage};
        \end{scope}
      }%
      \tcbset{notitle,nobeforeafter,halign=flush left,valign=top,enhanced,opacityfill=0,%
              fit algorithm=areasize,size=minimal,fit fontsize macros}
      \node[inner sep=0pt,outer sep=0pt,anchor=north west] at (\kit@sectionpage@tbox@upperleftx,\kit@sectionpage@tbox@upperlefty){%
        \tcboxfit[width=\kit@sectionpage@tbox@width,height=\kit@sectionpage@tbox@height,fit warning=off]{%
        {\usebeamerfont{section title}\usebeamercolor*[fg]{section title}\insertsection\par}}};
      \node[inner sep=0pt,outer sep=0pt,anchor=north east] (intro) at (\kit@footer@unilogo@lowerrightx,\kit@sectionpage@tbox@upperlefty){%
        {\usebeamerfont{section intro}\usebeamercolor*[fg]{section intro}\kit@sectionpage@intro\par}};
      \node[inner sep=0pt,outer ysep=2pt,anchor=north east] at (intro.south east){%
        {\usebeamerfont{section number}\usebeamercolor*[fg]{section number}\insertsectionnumber\par}};
    \end{tikzpicture}
    \endgroup%
  \end{textblock*}
}

%% part page
\defbeamertemplate*{part page}{KIT}{%
  \begin{textblock*}{\kit@paper@width}(0pt,0pt)
    \begingroup%
    \begin{tikzpicture}
      % setup bounding box
      \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@paper@height);
      \node[inner sep=0pt,outer sep=4pt,anchor=south,text width=\kit@partpage@tbox@width,align=center] (partn) at (0.5\kit@paper@width,0.5\kit@paper@height){%
        {\usebeamerfont{part name}\usebeamercolor*[fg]{part name}\kit@partpage@intro~~\insertromanpartnumber\par}%
      };
      \node[inner sep=0pt,outer sep=4pt,anchor=north,text width=\kit@partpage@tbox@width,align=center] (partt) at (0.5\kit@paper@width,0.5\kit@paper@height){%
        {\usebeamerfont{part title}\usebeamercolor*[fg]{part title}\insertpart\par}%
      };
    \end{tikzpicture}
    \endgroup%
  \end{textblock*}
}
